using System;
using System.Collections.Generic;
using Couchbase;
using Couchbase.Authentication;
using Couchbase.Configuration.Client;
using Couchbase.Core;
using Couchbase.Core.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Serialization;

namespace CouchbaseTests
{
    public class CouchbaseFactory 
    {
        public static IBucket InitializeBucket()
        {
            ClusterHelper.Initialize(new ClientConfiguration
            {
                Servers =new List<Uri>()
                {
                    new Uri("http://localhost:8091/pools")
                },
                Serializer = CreateSerializer
            });

            ClusterHelper
                .Get()
                .Authenticate(new PasswordAuthenticator("administrator","password"));

            var bucket = ClusterHelper.GetBucket("bucket");

            bucket.CreateManager("administrator", "password").CreateN1qlPrimaryIndex(false);

            return bucket;
        }

        private static DefaultSerializer CreateSerializer()
        {
            var settings = new JsonSerializerSettings();
            return new DefaultSerializer(settings, settings);
        }
    }
}